//+------------------------------------------------------------------+
//|                                                 ZigZag_Talex.mq4 |
//|                                                            Talex |
//|                                                 tan@gazinter.net |
//+------------------------------------------------------------------+
#property copyright "Talex"
#property link      "tan@gazinter.net"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

//---- input parameters
extern int ExtDepth=13;
extern int ExtPoint=6; /*  */
//---- indicator buffers
double ZZT[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(1);
   SetIndexBuffer(0,ZZT);
   SetIndexStyle(0,DRAW_SECTION);
 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   /**/
   int    i,zzbarlow,zzbarhigh,curbar,curbar1,curbar2;
   double curpr;
   bool flag;

   /**/
    
   zzbarlow=iLowest(NULL,0,MODE_LOW,ExtDepth,0);        
   zzbarhigh=iHighest(NULL,0,MODE_HIGH,ExtDepth,0);     
   
   if(zzbarlow<zzbarhigh) {curbar=zzbarlow; curpr=Low[zzbarlow];}
   if(zzbarlow>zzbarhigh) {curbar=zzbarhigh; curpr=High[zzbarhigh];}
   if(zzbarlow==zzbarhigh){curbar=zzbarlow;curpr=funk1(zzbarlow, ExtDepth);}
   
   ZZT[curbar]=curpr;
   Print("curbar1=",curbar,"; curpr1=",curpr);
   ExtPoint--;
   if(curpr==Low[curbar]) flag=true;
   else flag=false;
   
   i=curbar;
   while(ExtPoint>0)
   {
    if(flag)
    {
     while(i<=Bars-1)
     {
     curbar1=iHighest(NULL,0,MODE_HIGH,ExtDepth,i); 
     curbar2=iHighest(NULL,0,MODE_HIGH,ExtDepth,curbar1); 
     if(curbar1==curbar2){curbar=curbar1;curpr=High[curbar];flag=false;i=curbar+1;break;}
     else i=curbar2;
     }
    }
    Print("curbar=",curbar,"; curpr=",curpr);
    ZZT[curbar]=curpr;
    ExtPoint--;
    if(ExtPoint==0) break;
    
    if(!flag) 
    {
     while(i<=Bars-1)
     {
     curbar1=iLowest(NULL,0,MODE_LOW,ExtDepth,i); 
     curbar2=iLowest(NULL,0,MODE_LOW,ExtDepth,curbar1); 
     if(curbar1==curbar2){curbar=curbar1;curpr=Low[curbar];flag=true;i=curbar+1;break;}
     else i=curbar2;
     }
    }
    Print("curbar=",curbar,"; curpr=",curpr);
    ZZT[curbar]=curpr;
    ExtPoint--;
   }
   
   return(0);
  }
//+------------------------------------------------------------------+

/*-------------------------------------------------------------------+
/
/
/-------------------------------------------------------------------*/
double funk1(int zzbarlow, int ExtDepth)
{
 double pr;
 int fbarlow,fbarhigh;
 
 fbarlow=iLowest(NULL,0,MODE_LOW,ExtDepth,zzbarlow);  
 fbarhigh=iHighest(NULL,0,MODE_HIGH,ExtDepth,zzbarlow);
 
 if(fbarlow>fbarhigh)
 {
  if((Low[zzbarlow]<Low[fbarhigh]) && (High[zzbarlow]<High[fbarhigh])) pr=Low[zzbarlow];
 }
 if(fbarlow<fbarhigh)
 {
  if((Low[zzbarlow]>Low[fbarlow]) && (High[zzbarlow]>High[fbarlow])) pr=High[zzbarlow];
 }
 return(pr);
}